#include "definitions.h"

class QAbstractWallet : public QObject
{
    Q_OBJECT

signals:
    void balanceChanged();

public:
    QAbstractWallet(){}
    virtual ~QAbstractWallet(){}
    virtual void emitBalanceChanged(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}

    virtual Q_PROPERTY(long balance READ balance NOTIFY balanceChanged);
    virtual long balance(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}


    virtual Q_INVOKABLE int getAddressCount(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString getAddress(int num){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<QString> getAddresses(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString addAddress(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}

    virtual Q_INVOKABLE int             getTransactionCount(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE int             getTransactionValue(int tx){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString         getTransactionMyAddress(int tx){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString         getTransactionTheirAddress(int tx){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString         getTransactionTimestamp(int tx){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE int             getTransactionConfidence(int tx){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString         getTransactionHash(int tx){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<int>      getTransactionValues(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<QString>  getTransactionTheirAddresses(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<QString>  getTransactionMyAddresses(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<QString>  getTransactionTimestamps(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<int>      getTransactionConfidences(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QList<QString>  getTransactionHashes(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}


    virtual Q_INVOKABLE void sendCoins(int amount, QString address){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE QString createRequest(QList<QString> amount, QList<QString> address){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE int getFee(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE int getTotal(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    virtual Q_INVOKABLE void sendTransaction(){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
    
    virtual Q_INVOKABLE bool addressIsValid(QString address){std::cout << "UNIMPLIMENTED FUNCTION CALL" << std::endl;}
};
